Subject: Re: bug#59686: 30.0.50; tree-sitter indentation in some loops and conditional statements is wrong

From: Eli Zaretskii <[email-masked]>
Date: Fri, 02 Dec 2022 10:39:21 +0200

> Cc: [email-masked]
> Date: Fri, 02 Dec 2022 06:42:03 +0100
> From:  Theodor Thornhill via "Bug reports for GNU Emacs,
>  the Swiss army knife of text editors" <[email-masked]>
> 
> >> // -*- c-ts -*-
> >> int main() {
> >>    for (int i=0; i<10; ++i) {
> >>      foo(i);
> >>    }
> >>
> >>    for (int i=0;
> >>           i<10;
> >>           ++i) {
> >>             foo(i);
> >>           }
> >> }
> >
> >I see, that’s because the indent rule finds the BOL of the line where
> >the "{" is on, and indents from there.  Theo, WDYT? Does indent style 
> >fix this, or we should change the indent rules?
> >
> >Yuan
> 
> I've seen this issue myself, and have tried several combinations to fix it. It is trivial to fix this particular case, but because compound_statement is used everywhere problems will pop up other places. The fix here would be some grand-parent-bol function, but if my memory serves that would mess up the else in an if else. I'm happy to see this fixed, but just remember that it's not _super_ trivial.
> 
> Other languages exhibit similar issues, but with other constructs.

FWIW, this is an unusual style, so I see no catastrophe if it is not 110%
according to expectations.  Users can easily fix that by tweaking their BOLs
where important.